% merge all identical and adjacent values
% input a m*1 vector
% return regions a m*3 matrix, where col1 = start_pos (from index),
% col2=end_pos and col3=element(from index) (=cluster_id)
%
% ie if index = [ 1 1 1 2 2 3 3 4]
% it will return  
%      1     3     1
%      4     5     2
%      6     7     3
function regions=find_adjacent_regions(index)

regions=[];
diff = abs(index(1:end-1) - index(2:end) ) ;
indexes = find(diff > 0);
if(indexes)    
    real_indexes = [1 ; indexes + 1];
     for i=1:length(real_indexes)-1
         regions=[regions;[ real_indexes(i) real_indexes(i+1)-1 index(real_indexes(i))]];
     end  
      if(regions(end,2) ~= length(index) )
        % don't leave a region behind !!
         regions=[regions;[ real_indexes(end) length(index) index(real_indexes(end))]];
      end
else
   regions=[1 length(index) index(1)]; 
end
end