% create regions from matrix regions ( containing start,end index for SNPs
% in localSNP, assume all regions are from same chr)
%
% regions = [ startIndex, endIndex, regionId], where start/endIndex
% correspond to an element in vector 'pos'
% pos = vector of genomic position
% freq = CNV variation frequency at each Marker
function merged_genomic_regions=create_region_from_snps(regions,pos,chr, freq)


% convert these regions (using CNV index) into proper genomic regions (with
% genomic coords)
merged_genomic_regions=zeros(size(regions,1),8);
for index=1:size(regions,1)

    mystart=pos(regions(index,1));
    myend=pos(regions(index,2));
    nSNPs=regions(index,2)-regions(index,1)+1;

    merged_genomic_regions(index,:) =[
        regions(index,end) ,... % add cluster id
        chr ,mystart, myend, ... % chr,start,end pos
        nSNPs,  ... % #SNPs in regions
        min(freq(regions(index,1): regions(index,2))), ...%get min,median,max for CNV freq
        median(freq(regions(index,1): regions(index,2))),...
        max(freq(regions(index,1): regions(index,2))), ...
        ]         ;



end